#!/bin/ksh
#***********************************************************************
# Program name  : frncrtos.oracle                                      *
#                                                                      *
# Description   : This script is for add Object server                 *
#                 database userid and password will be prompted        *
# ssw 102397 created                                                   *
#***********************************************************************

export FRNROOT=.

# Display copyright statement
cat copyright

# Setup message variables
. ./frnxcosm.sh

# Confirm that the given database name is ok
dspmsg $MSG_MSGFILE $MSG_OSCONFIRMDBNAME "$MSG_MSGNOTFOUND" "$FRNDBNAME"
read answer
if [[ -n "$answer" ]]            # Something non-null entered, so exit
  then
     # Must run config to change database name
     dspmsg $MSG_MSGFILE $MSG_OSCHANGEDBNAME "$MSG_MSGNOTFOUND" "$FRNROOT"
     return 4
fi

FRNODBNAME=$FRNDBNAME
ORACLE_SID=$FRNDBNAME
export FRNODBNAME
export ORACLE_SID
dbname=$1
# get the userid for create database tables
VALIDDB=0
until [[ "$VALIDDB" = 1 ]]; do
   dspmsg $MSG_MSGFILE $MSG_ENTERDBUSERID "$MSG_MSGNOTFOUND"
   read answer
   if [[ -z "$answer" ]]; then    # is string missing?
      dspmsg $MSG_MSGFILE $MSG_NODBUSERID "$MSG_MSGNOTFOUND"
      VALIDDB=1
      exit 0
   else
      # check to make sure length does not exceed 8 characters+newline
      if
         echo "$answer" | wc -c | awk '{ if ($1 > 9)
            {
               exit(1)
            }
         else {
               exit(0)
            }
         }'
      then
         VALIDDB=1
         FRNUSERID=$answer
         export FRNUSERID
      else
         VALIDDB=1
         dspmsg $MSG_MSGFILE $MSG_USERIDTOOLONG "$MSG_MSGNOTFOUND" "$answer"
         exit 1
      fi  #
   fi # end of string mistting
done

# get the password for oracle
VALIDDB=0; # reset edit switch
until [[ "$VALIDDB" = 1 ]]; do
# Please enter the password for userid $FRNUSERID
   dspmsg $MSG_MSGFILE $MSG_ENTERDBPASSWORD "$MSG_MSGNOTFOUND" "$FRNUSERID"
   stty -echo
   read FRNPASSWD
   stty echo
   echo
   if [[ -z "$FRNPASSWD" ]]; then    # is string missing?
      dspmsg $MSG_MSGFILE $MSG_NOPASSWORD "$MSG_MSGNOTFOUND"
      VALIDDB=1
      exit 1
   else
      VALIDDB=1
      export FRNPASSWD
   fi
done  # end of until do loop

VALIDDB=0; # reset edit switch
usr=`whoami`
usrhome=`grep "^$usr:" /etc/passwd|cut -f6 -d:`


printf "select max(bos_objectserverid)+1 from base_objectserver;" > $usrhome/sel_objectserver.sql
if [[ $? -eq 0 ]]; then


sel_result=`svrmgrl<<- EOF
connect $FRNUSERID/$FRNPASSWD
@$usrhome/sel_objectserver.sql
exit;
EOF`
selerr=`echo $sel_result|egrep 'ORA-|DBA-' |wc -l`

   if (( selerr == 0 )); then
      OBJ_ID=`echo $sel_result|sed 's/..*  *----------  *//g'|cut -d" " -f1`
      printf "insert into base_objectserver values(%s, '%s', 0 );" "$OBJ_ID" "$dbname" > $usrhome/ins_objectserver.sql
ins_result=`svrmgrl<<- EOF
connect $FRNUSERID/$FRNPASSWD
@$usrhome/ins_objectserver.sql
exit;
EOF`
      inserr=`echo $ins_result|egrep 'ORA-|DBA-' |wc -l`
      if (( inserr == 0 )); then
         dspmsg $MSG_MSGFILE $MSG_DBCREATEDONE "$MSG_MSGNOTFOUND" "$FRNDBNAME"_
         rm $usrhome/ins_objectserver.sql $usrhome/sel_objectserver.sql
      else
         echo $ins_result|egrep 'ORA-|DBA-' | sed 's/ /\
/g' > ins_err.log
         errcode=`egrep 'ORA-|DBA-' ins_err.log|sed s/://g`
         dspmsg $MSG_MSGFILE $MSG_NOTCREATED "$MSG_MSGNOTFOUND" "$FRNDBNAME"
      fi
   else
      echo $sel_result|egrep 'ORA-|DBA-' | sed 's/ /\
/g' > $usrhome/sel_err.log
      errcode=`egrep 'ORA-|DBA-' sel_err.log|sed s/://g`
      dspmsg $MSG_MSGFILE $MSG_NOTCREATED "$MSG_MSGNOTFOUND" "$FRNDBNAME"
   fi
else
   dspmsg $MSG_MSGFILE $MSG_ NOTCREATED "$MSG_MSGNOTFOUND" "$FRNDBNAME"
fi

