#!/bin/ksh
#***********************************************************************
# Digital Library Version 2 - 5765-C86.                                *
# VisualInfo Version 2 Release 3.0 - 5697-250.                         *
# (C) Copyright IBM Corp. 1994,1997.                                   *
# All Rights Reserved.                                                 *
#                                                                      *
# US Government Users Restricted Rights                                *
# Use, duplication or disclosure restricted by GSA ADP Schedule        *
# Contract with IBM Corp.                                              *
# Licensed Materials - Property of IBM                                 *
#***********************************************************************
#***********************************************************************
#  Program Name:  frnxmili.db2.sh                                      *
#  Library Server AIX DB2 Database migration from DL V1 to V2          *
#***********************************************************************
cat copyright

echo "\nEnter Library Server database name: "
read dbname
if [ -z "$dbname" ]; then
   echo "\nCan not proceed without Library Server database name, exit"
   exit 1
else
   typeset -u dbname
   export FRNDB=$dbname
fi

#Get DB2 instance
echo "\nEnter DB2 instance: "
read answer
if [ -z "$answer" ]; then
   echo "\nCan not proceed without DB2 instance name, exit "
else
   export DB2INSTANCE=$answer
fi

#locate instance home directory
INSTHOME=`grep "^$DB2INSTANCE:" /etc/passwd|cut -f6 -d:`
export INSTHOME

#source DB2 Profile
. $INSTHOME/sqllib/db2profile

#The exp directory is where the exported ixf files are
export EXPDIR=`pwd`/exp

#Make sure that we start out with a file that has nothing in it.
cat /dev/null > $EXPDIR/imp.cmd

IMPLST=$EXPDIR/imp.cmd
TBLLST1=$EXPDIR/part.lst
TBLLST2=$EXPDIR/extratbl.lst
TBLLST3=$EXPDIR/icvextra.lst
CNSTLST=$EXPDIR/cnsttbl.lst


#Delete all data from the tables.

echo "DELETE FROM AVT00001"           > delrows.sql
echo "DELETE FROM AVT00002"           >> delrows.sql
echo "DELETE FROM AVT00003"           >> delrows.sql
echo "DELETE FROM AVT00004"           >> delrows.sql
echo "DELETE FROM AVT00005"           >> delrows.sql
echo "DELETE FROM AVT00006"           >> delrows.sql
echo "DELETE FROM AVT00007"           >> delrows.sql
echo "DELETE FROM SBTACCESSLIST"      >> delrows.sql
echo "DELETE FROM SBTCHECKEDOUT"      >> delrows.sql
echo "DELETE FROM SBTCNTL"            >> delrows.sql
echo "DELETE FROM SBTDESCRIPTIONS"    >> delrows.sql
echo "DELETE FROM SBTEVENTS"          >> delrows.sql
echo "DELETE FROM SBTFOREIGNPARTSNMS" >> delrows.sql
echo "DELETE FROM SBTGRAVEYARD"       >> delrows.sql
echo "DELETE FROM SBTITEMS"           >> delrows.sql
echo "DELETE FROM SBTLICENSEKEY"      >> delrows.sql
echo "DELETE FROM SBTLICVIOLATIONS"   >> delrows.sql
echo "DELETE FROM SBTLINKS"           >> delrows.sql
echo "DELETE FROM SBTNAMES"           >> delrows.sql
echo "DELETE FROM SBTNLSKEYWORDS"     >> delrows.sql
echo "DELETE FROM SBTNLSLANGUAGES"    >> delrows.sql
echo "DELETE FROM SBTPARTS"           >> delrows.sql
echo "DELETE FROM SBTPATRONGROUP"     >> delrows.sql
echo "DELETE FROM SBTPATRONS"         >> delrows.sql
echo "DELETE FROM SBTPRIVILEGES"      >> delrows.sql
echo "DELETE FROM SBTPROPERTIES"      >> delrows.sql
echo "DELETE FROM SBTSBTABLES"        >> delrows.sql
echo "DELETE FROM SBTSTATICQUERIES"   >> delrows.sql
echo "DELETE FROM SBTVIEWATTRS"       >> delrows.sql
echo "DELETE FROM SBTVIEWDEFS"        >> delrows.sql
echo "DELETE FROM SBTWIPITEMS"        >> delrows.sql
echo "DELETE FROM SBTWIPSUSPITEMS"    >> delrows.sql
echo "DELETE FROM SBTCLASSDEFS"       >> delrows.sql
echo "DELETE FROM SBTQUERYEXPRS"      >> delrows.sql
echo "DELETE FROM SBTATTRDEFS"        >> delrows.sql
echo "DELETE FROM SBTCOLLNAME"        >> delrows.sql
echo "DELETE FROM SBTOBJECTSERVER"    >> delrows.sql
echo "DELETE FROM SBTACCESSCODES"     >> delrows.sql
echo "DELETE FROM ICV00002"           >> delrows.sql
echo "DELETE FROM ICV00003"           >> delrows.sql
echo "DELETE FROM ICV00004"           >> delrows.sql
echo "DELETE FROM ICV00005"           >> delrows.sql
echo "DELETE FROM ICV00006"           >> delrows.sql
echo "DELETE FROM ICV00007"           >> delrows.sql
echo "DROP TABLE  AVT00001"           >> delrows.sql
echo "DROP VIEW   ICV00001"           >> delrows.sql
echo "DROP TABLE  AVT00008"           >> delrows.sql
echo "DROP VIEW   ICV00008"           >> delrows.sql
echo "DROP TABLE  AVT00009"           >> delrows.sql
echo "DROP VIEW   ICV00009"           >> delrows.sql
echo "DROP TABLE  AVT00010"           >> delrows.sql
echo "DROP VIEW   ICV00010"           >> delrows.sql
echo "DROP TABLE  AVT00011"           >> delrows.sql
echo "DROP VIEW   ICV00011"           >> delrows.sql
echo "DROP TABLE  AVT00012"           >> delrows.sql
echo "DROP VIEW   ICV00012"           >> delrows.sql
echo "DROP TABLE SBTCLASSATTRS"       >> delrows.sql

#create new AVT Tables

echo "CREATE TABLE AVT00001(ItemID            CHAR(16)        NOT null,       \ " >> delrows.sql
echo "                      ATTRIBUTE00001    SMALLINT        NOT null,       \ " >> delrows.sql
echo "                      ATTRIBUTE00002    CHAR(8)         NOT null,       \ " >> delrows.sql
echo "                      ATTRIBUTE00003    VARCHAR(40))                      " >> delrows.sql

echo "CREATE UNIQUE INDEX AVT1INDX ON AVT00001                                \ " >> delrows.sql
echo "                     (ITEMID   ASC)                                       " >> delrows.sql

echo "CREATE UNIQUE INDEX SBUXAVT0000101 ON AVT00001                          \ " >> delrows.sql
echo "                     (ATTRIBUTE00001    ASC )                             " >> delrows.sql

echo "CREATE TABLE SBTCLASSATTRS (ClassID           SMALLINT        NOT null, \ " >> delrows.sql
echo "                          AttributeID         SMALLINT        NOT null, \ " >> delrows.sql
echo "                          SequenceNum         SMALLINT        NOT null, \ " >> delrows.sql
echo "                          AttrFlags           SMALLINT        NOT null, \ " >> delrows.sql
echo "        FOREIGN KEY(ClassID) REFERENCES SBTCLASSDEFS ON DELETE CASCADE, \ " >> delrows.sql
echo "        FOREIGN KEY(AttributeID) REFERENCES SBTATTRDEFS)                  " >> delrows.sql

echo "CREATE UNIQUE INDEX SBUXCLASSATTR01 ON SBTCLASSATTRS                    \ " >> delrows.sql
echo "               ( ClassID     ASC,                                       \ " >> delrows.sql
echo "                 AttributeID ASC)                                         " >> delrows.sql

echo "CREATE UNIQUE INDEX SBUXCLASSATTR02 ON SBTCLASSATTRS                    \ " >> delrows.sql
echo "               ( ClassID     ASC,                                       \ " >> delrows.sql
echo "                 SequenceNum ASC )                                        " >> delrows.sql
echo "ALTER TABLE SBTCLASSATTRS ADD MVTTABLENAME CHARACTER(13)                  " >  alter.sql
echo "UPDATE SBTCLASSATTRS set MVTTABLENAME=''                                  " >> alter.sql

#Get List of tables that need to have their constraints checked.
echo "SELECT TABNAME FROM SYSCAT.TABLES WHERE                                 \ " >  getcnst.sql
echo "(TABNAME LIKE 'SBT%' OR TABNAME LIKE 'AVT%') AND                        \ " >> getcnst.sql
echo "STATUS='C'                                                                " >> getcnst.sql

#Run reorg on all tables
echo "REORGCHK ON TABLE ALL                                                     " > $EXPDIR/runstat.sql

#To Regenerate DLL's do the following
echo "UPDATE SBTCLASSDEFS SET DLLSTATUS=-1 WHERE CLASSID>0                      " >  $EXPDIR/setstus.sql
echo "UPDATE SBTVIEWDEFS SET DLLSTATUS=1 WHERE DLLSTATUS=0                      " >> $EXPDIR/setstus.sql
# svt11281 changed WHERE clause to CLASSID>0 for CLASSDEFS and
#          added clause to VIEWDEFS (DLLSTATUS=0) DAW

#In older versions of DB2 the views are created with a high level user qualifier.
#Need to strip the ROOT. from the create view statements. This should not affect
#views created from later versions of DB2 as the high level ROOT qualifier will not
#be present.

sed '/"ROOT"\./s///g' $EXPDIR/icvextra.lst > $EXPDIR/icv.lst

#To set the Buff page to the original value
buffpage=`cat $EXPDIR/dbcfg.lst |grep BUFFPAGE | awk '{print $7}'`
echo "update db cfg for $FRNDB using BUFFPAGE $buffpage" > $EXPDIR/upbfpg.sql


#load data into the tables.
if [[ -d $EXPDIR ]]; then
   for tblnm in `cat $TBLLST1`
   do
      echo "load from $EXPDIR/$tblnm.ixf of IXF SAVECOUNT 10000 messages $EXPDIR/$tblnm.msg replace into $tblnm" >> $IMPLST
      if [[ $? -ne 0 ]]; then
         echo "Error: Appending $tblnm to $IMPLST"
      fi
   done

   #load data into AVT Tables. Need to IMPORT first to create the tables and then
   #LOAD the tables with data.
   for i in `cat $TBLLST2`
   do
      echo "import from $EXPDIR/$i.def.ixf of IXF commitcount 10000 messages $EXPDIR/$i.imp.msg create into $i" >> $IMPLST
      echo "load from $EXPDIR/$i.ixf of IXF savecount 10000 messages $EXPDIR/$i.msg replace into $i" >> $IMPLST
      if [[ $? -ne 0 ]]; then
         echo "Error: Appending $i to $IMPLST"
      fi
   done
  
   #Start DB2
   echo " "
   echo "Starting the database manager ...."
   db2 db2start > /dev/null 2>&1

   #Connect to the Database
   echo " "
   echo "Connecting to the database ...."
   db2 connect to $FRNDB > /dev/null 2>&1
   if [[ $? -ne 0 ]]; then
      echo "Error: Cannot connect to the database"
      exit 1
   fi

   #Delete all rows from the tables.
   echo " "
   echo "Deleting sample data ...."
   db2 -fdelrows.sql -z$EXPDIR/delete.log > /dev/null 2>&1
   cnt=`egrep -v "SQL0100W|DB20000I|SQLSTATE=02000|^$" $EXPDIR/delete.log|wc -l`
   if (( $cnt != 0 )); then
      echo "Error: Deleting sample data. see delete.log"
      exit 1
   fi
   rm delrows.sql

   #start out with a clean log file
   cat /dev/null > $EXPDIR/imp.log

   #load the tables with data
   echo " "
   echo "Loading exported data ...."
   db2 -f$IMPLST -z$EXPDIR/imp.log > /dev/null 2>&1
   if [[ $? -lt 3 ]]; then
      cat /dev/null > $EXPDIR/cnst.lst

      #Get a list of tables that need to have their constraints checked
      echo "Generating constraint list ...."
      db2 -fgetcnst.sql -r$EXPDIR/cnst.lst > /dev/null 2>&1
      egrep -v "^TABNAME|^---|record\(s\) selected|^$" $EXPDIR/cnst.lst > $EXPDIR/cnsttbl.lst

      for tbl in `cat $CNSTLST`
      do
         echo "set constraints for $tbl immediate checked" >> constlst.sql
         if [[ $? -ne 0 ]]; then
            echo "Error: Appending $tbl to $CNSTLST"
            exit 1
         fi
      done

    
      rm $EXPDIR/cnst.lst    > /dev/null 2>&1
      rm $EXPDIR/cnsttbl.lst > /dev/null 2>&1
      rm getcnst.sql > /dev/null 2>&1

      #Check the tables for RI
      echo " "
      echo "Checking constraints ...."
      db2 -fconstlst.sql -z$EXPDIR/cnstrnt.log >/dev/null 2>&1
      if [[ $? -ne 0 ]]; then
         echo " Error: Checking constraints for tables."
         echo " See $EXPDIR/cnstrnt.log for details."
         exit 1
      fi

      rm constlst.sql > /dev/null 2>&1

      db2 -falter.sql -z$EXPDIR/alter.log > /dev/null 2>&1

      #Create User created AVT Tables
      echo " "
      echo "Creating Views ...."
      db2 -f$EXPDIR/icv.lst -z$EXPDIR/crtvew.log > /dev/null 2>&1
      if [[ $? -ne 0 ]]; then
         echo "Error: Creating Views. "
         echo "See $EXPDIR/crtvew.log for details."
         exit 1
      fi

      `pwd`/frnxmilt.db2.exe $FRNDB
      if [[ $? -ne 0 ]]; then
         echo "Error: On execution of frnxmilt.db2.exe."
         echo "See frnxmilt.msg for details"
         exit 1
      fi

      #Run Reorg check on all the tables
      echo " "
      echo "Updating statistics ...."
      db2 -f$EXPDIR/runstat.sql -z$EXPDIR/runstat.log > /dev/null 2>&1
      if [[ $? -ne 0 ]]; then
            echo "Error: Updating statistics. See $EXPDIR/runstat.log for details"
      fi

      rm $EXPDIR/runstat.sql > /dev/null 2>&1

      #restore buffpage size to the previous version db value
      echo " "
      echo "Updating BuffPage size ...."
      db2 -f$EXPDIR/upbfpg.sql -z$EXPDIR/upbfpg.log > /dev/null 2>&1

      rm $EXPDIR/upbfpg.sql > /dev/null 2>&1

      #Bind the database
      if [[ -a /usr/lpp/frn/bin/frnbind.lib ]]; then
         echo " "
         echo "The Database is being bound to the plan ...."
         /usr/lpp/frn/bin/frnbind.lib   > /dev/null 2>&1
      else
         echo "ERROR: Cannot find frnbind.lib in /usr/lpp/frn/bin"
      fi

      #Set values in tables to regenerate Views and Index Classes
      db2 -f$EXPDIR/setstus.sql -z$EXPDIR/view.log > /dev/null 2>&1
      if [[ $? -ne 0 ]]; then
            echo "Error: On changing DLLSTATUS in  SBTCLASSDEFS/SBTVIEWDEFS tables."
            echo "See $EXPDIR/view.log for details"
      fi
     
      rm $EXPDIR/setstus.sql > /dev/null 2>&1
      rm $EXPDIR/icv.lst     > /dev/null 2>&1
      echo "Data load to $FRNDB finished successfully."
   else
      echo "\ncheck $EXPDIR/imp.log and $EXPDIR/<TABLENAME>.msg for error"
      exit 1
   fi
else
   echo "Can not proceed without subdirectory exp"
   exit 1
fi
