#!/bin/ksh
#***********************************************************************
# Digital Library Version 2 - 5765-C86.                                *
# VisualInfo Version 2 Release 3.0 - 5697-250.                         *
# (C) Copyright IBM Corp. 1994,1997.                                   *
# All Rights Reserved.                                                 *
#                                                                      *
# US Government Users Restricted Rights                                *
# Use, duplication or disclosure restricted by GSA ADP Schedule        *
# Contract with IBM Corp.                                              *
# Licensed Materials - Property of IBM                                 *
#***********************************************************************
#***********************************************************************
# Program name  : frnxmioe.db2.sh                                      *
#                                                                      *
# Description   : Object server database migration                     *
#                     from AIX DB2 DL V1 to V2                         *
#***********************************************************************
cat copyright

echo "\nEnter Object Server database name: "
read dbname
if [ -z "$dbname" ]; then
   echo "\nCan not proceed without DB2 database name, exit"
   exit 1
else
   typeset -u dbname
   export FRNDB=$dbname
fi
echo "\nEnter DB2 instance: "
read answer
if [ -z "$answer" ]; then
   echo "\nCan not proceed without DB2 instance name, exit "
else
   export DB2INSTANCE=$answer
fi
 
#locate instance home directory
INSTHOME=`grep "^$DB2INSTANCE:" /etc/passwd|cut -f6 -d:`
export INSTHOME
. $INSTHOME/sqllib/db2profile

export EXPDIR=`pwd`/exp

export NODATA=`pwd`/nodata
if [[ -d $EXPDIR ]]; then
   rm $EXPDIR/* > /dev/null 2>&1
else
   mkdir $EXPDIR > /dev/null 2>&1
   if [[ $? -eq 0 ]]; then
      echo "\nDirectory $EXPDIR did not exist, the migration"
      echo "  program created $EXPDIR directory."
   else
      echo "\nCreate directory $EXPDIR failed, exit"
      exit 1
   fi
fi
if [[ -d $NODATA ]]; then
   rm $NODATA/* > /dev/null 2>&1
else
   mkdir $NODATA > /dev/null 2>&1
   if [[ $? -eq 0 ]]; then
      echo "\nDirectory $NODATA did not exist, the migration"
      echo "  program created $NODATA directory"
   else
      echo "\nCreate directory $NODATA failed, exit"
      exit 1
   fi
fi
cat /dev/null > $EXPDIR/obj_tbl.lst
TBLLST=$EXPDIR/obj_tbl.lst

echo BASE_CNTL >> $TBLLST
echo BASE_DEVMGR >> $TBLLST
echo BASE_OBJECTSERVER >> $TBLLST
echo BASE_STORAGECLASS >> $TBLLST
echo BASE_STORAGEGROUP >> $TBLLST
echo BASE_MGTCLASS >> $TBLLST
echo BASE_MGTTRANSITION >> $TBLLST
echo BASE_COLLECTIONS >> $TBLLST
echo BASE_STRINGS >> $TBLLST
echo BASE_STGCLSDEVMGR >> $TBLLST
echo BASE_STGGRPCLASS >> $TBLLST
echo BASE_VOLUMES >> $TBLLST
echo BASE_STGGRPVOLUME >> $TBLLST
echo BASE_STAGING >> $TBLLST
echo SBTSBTABLES >> $TBLLST
echo BASE_LIBRARYSERVER >> $TBLLST
echo BASE_OBJECTS >> $TBLLST
echo BASE_ACCESS >> $TBLLST 

#get db config
echo "get db cfg for $FRNDB" > dbcfg.sql


cat /dev/null > $EXPDIR/exp.lst
cat /dev/null > $EXPDIR/exp.log
for tblnm in `cat $TBLLST`
do
  echo "export to $EXPDIR/$tblnm.ixf of IXF messages $EXPDIR/$tblnm.msg select * from ROOT.$tblnm" >> $EXPDIR/exp.lst  
  if [[ $? -ne 0 ]]; then
            echo "\nFailed to store $tblnm.ixf in $EXPDIR"
         fi
done
#use existing file obj_exp.cmd to get files needed here
db2start
#Get DB config
db2 -fdbcfg.sql -r$EXPDIR/dbcfg.lst

db2 connect to $FRNDB
db2 -f$EXPDIR/exp.lst -z$EXPDIR/exp.log
if [[ $? -ne 0 ]]; then
   echo "Error occurred while exporting data, see $EXPDIR/exp.log"
   echo "also, check $EXPDIR/<TABLENAME>.msg"
else
   echo "Data exporte from $FRNDB has been completed, see $EXPDIR/exp.log"
fi
