#!/bin/ksh
#***********************************************************************
# Digital Library Version 2 - 5765-C86.                                *
# VisualInfo Version 2 Release 3.0 - 5697-250.                         *
# (C) Copyright IBM Corp. 1994,1997.                                   *
# All Rights Reserved.                                                 *
#                                                                      *
# US Government Users Restricted Rights                                *
# Use, duplication or disclosure restricted by GSA ADP Schedule        *
# Contract with IBM Corp.                                              *
# Licensed Materials - Property of IBM                                 *
#***********************************************************************
#***********************************************************************
# Program name  : frnxmiou.db2.sh                                      *
#                                                                      *
# Description   : Object server database migration                     *
#                     from AIX DB2 to Oracle                           *
#***********************************************************************
#if [[ "$FRNDEBUG" = "1" ]]; then set -x; fi   # enable diagnostics
 
# Setup message variables
#. $FRNROOT/frnxcosm.sh

# Check for setting of required environment variable
#if [[ ! -d "$FRNROOT" ]]; then
   #echo "Required environment variable not set correctly: FRNROOT=$FRNROOT"
   # echo "You must first run a configured setup script to proceed."
#   dspmsg $MSG_MSGFILE $MSG_REQVARNOTSET "$MSG_MSGNOTFOUND" "FRNROOT=$FRNROOT"
#   return 1
#fi

# Display copyright statement
cat copyright

# Check for setting of all required environment variables
#$FRNROOT/frncheck

echo "Enter DB2 database name: \c"
#dspmsg $MSG_MSGFILE $MSG_READDBNAME2 "$MSG_MSGNOTFOUND"
read answer
if [ -z "$answer" ]; then
   echo "Can not proceed without DB2 database name, exit"
   #dspmsg $MSG_MSGFILE $MSG_NODBNAME "$MSG_MSGNOTFOUND"

   exit 1
else
   export FRNDB=$answer
fi
echo "Enter DB2 instance: \c"
#dspmsg $MSG_MSGFILE $MSG_READDBINSTANCE "$MSG_MSGNOTFOUND"
read answer
if [ -z "$answer" ]; then
   echo "Can not proceed with a DB2 instance name, exit"
   #dspmsg $MSG_MSGFILE $MSG_NODBINSTANCE "$MSG_MSGNOTFOUND"
else
   export DB2INSTANCE=$answer
fi
#locate instance home directory
INSTHOME=`grep "^$DB2INSTANCE:" /etc/passwd|cut -f6 -d:`
export INSTHOME
. $INSTHOME/sqllib/db2profile

export EXPDIR=`pwd`/exp
export NODATA=`pwd`/nodata
if [[ -d $EXPDIR ]]; then
   rm $EXPDIR/* > /dev/null 2>&1
else
   mkdir $EXPDIR > /dev/null 2>&1
   if [[ $? -eq 0 ]]; then
      echo "\nDirectory $EXPDIR did not exist, the migration"
      echo "  program created $EXPDIR directory."
      #dspmsg $MSG_MSGFILE $MSG_DIRCREATED "$MSG_MSGNOTFOUND" "$EXPDIR"
   else
      echo "\nCreate directory $EXPDIR failed, exit"
      #dspmsg $MSG_MSGFILE $MSG_MKDIRFAILED "$MSG_MSGNOTFOUND" "$EXPDIR"
      exit 1
   fi
fi
if [[ -d $NODATA ]]; then
   rm $NODATA/* > /dev/null 2>&1
else
   mkdir $NODATA > /dev/null 2>&1
   if [[ $? -eq 0 ]]; then
      echo "\nDirectory $NODATA did not exist, the migration"
      echo "  program created $NODATA directory"
      #dspmsg $MSG_MSGFILE $MSG_DIRCREATED "$MSG_MSGNOTFOUND" "$NODATA"
   else
      echo "\nCreate directory $NODATA failed, exit"
      #dspmsg $MSG_MSGFILE $MSG_MKDIRFAILED "$MSG_MSGNOTFOUND" "$NODATA"
      exit 1
   fi
fi

echo BASE_CNTL > obj_tbl.lst
echo BASE_DEVMGR >> obj_tbl.lst
echo BASE_OBJECTSERVER >> obj_tbl.lst
echo BASE_STORAGECLASS >> obj_tbl.lst
echo BASE_STORAGEGROUP >> obj_tbl.lst
echo BASE_MGTCLASS >> obj_tbl.lst
echo BASE_MGTTRANSITION >> obj_tbl.lst
echo BASE_COLLECTIONS >> obj_tbl.lst
echo BASE_STRINGS >> obj_tbl.lst
echo BASE_STGCLSDEVMGR >> obj_tbl.lst
echo BASE_STGGRPCLASS >> obj_tbl.lst
echo BASE_VOLUMES >> obj_tbl.lst
echo BASE_STGGRPVOLUME >> obj_tbl.lst
echo BASE_STAGING >> obj_tbl.lst
echo SBTSBTABLES >> obj_tbl.lst
echo BASE_LIBRARYSERVER >> obj_tbl.lst
echo BASE_OBJECTS >> obj_tbl.lst
echo BASE_ACCESS >> obj_tbl.lst

echo export to exp/BASE_CNTL.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK  SELECT \* FROM \"ROOT\".BASE_CNTL > obj_exp.sql

echo export to exp/BASE_DEVMGR.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_DEVMGR >> obj_exp.sql

echo export to exp/BASE_OBJECTSERVER.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_OBJECTSERVER >> obj_exp.sql

echo export to exp/BASE_STORAGECLASS.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_STORAGECLASS >> obj_exp.sql

echo export to exp/BASE_STORAGEGROUP.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_STORAGEGROUP >> obj_exp.sql

echo export to exp/BASE_MGTCLASS.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_MGTCLASS >> obj_exp.sql

echo export to exp/BASE_MGTTRANSITION.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_MGTTRANSITION >> obj_exp.sql

echo export to exp/BASE_COLLECTIONS.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_COLLECTIONS >> obj_exp.sql

echo export to exp/BASE_STRINGS.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_STRINGS >> obj_exp.sql

echo export to exp/BASE_STGCLSDEVMGR.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_STGCLSDEVMGR >> obj_exp.sql

echo export to exp/BASE_STGGRPCLASS.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_STGGRPCLASS >> obj_exp.sql

#echo export to exp/BASE_VOLUMES.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_VOLUMES >> obj_exp.sql

echo export to exp/BASE_STGGRPVOLUME.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_STGGRPVOLUME >> obj_exp.sql

#BASE_STAGING has 1 column length over 254, db2 export to ascii file truncates data if length over 254. 
#use select statement instead
#echo export to exp/BASE_STAGING.del of DEL modified by CHARDEL| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_STAGING >> obj_exp.sql

echo export to exp/SBTSBTABLES.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".SBTSBTABLES >> obj_exp.sql

echo export to exp/BASE_LIBRARYSERVER.del of DEL modified by CHARDEL\| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_LIBRARYSERVER >> obj_exp.sql

#echo export to exp/BASE_OBJECTS.del of DEL modified by CHARDEL| DATESISO DECPLUSBLANK SELECT \* FROM \"ROOT\".BASE_OBJECTS >> obj_exp.sql

echo select * from \"ROOT\".base_access > obj_exp1.sql
#use decimal function to format the scientific notation to numeric 
echo select sta_id, decimal\(sta_size,31\), decimal\(sta_spaceused,31\), sta_percentstart, \\ > obj_exp2.sql
echo    sta_percentstop, sta_serveractive, sta_path from \"ROOT\".base_staging >> obj_exp2.sql
echo select vol_volumeid, vol_logicalname, vol_devmgrid, vol_stgclassid, \\ > obj_exp3.sql
echo    decimal\(vol_size,31\), decimal\(vol_freespace,31\), vol_attributes, vol_mediatype, vol_status, \\  >> obj_exp3.sql 
echo    vol_numbuckets, vol_referenceddate, vol_offlineloc from \"ROOT\".base_volumes >> obj_exp3.sql
echo select vol_mountpoint, vol_path from \"ROOT\".base_volumes > obj_exp4.sql
echo select obj_objectname, obj_collectionid, obj_mgtclassid, obj_stgclassid, \\ > obj_exp5.sql
echo    obj_volumeid, obj_path, obj_filename, obj_attributes, obj_status, \\ >> obj_exp5.sql
echo    decimal\(obj_size,31\), obj_createdate, obj_referenceddate, obj_actiondate, \\ >> obj_exp5.sql
echo    obj_mgtclassdate, obj_stgclassdate, obj_retention, obj_libraryid from \"ROOT\".base_objects >> obj_exp5.sql

echo select tbname, name, coltype, length, nulls, keyseq, colno \\ > obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_CNTL\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_DEVMGR\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_OBJECTSERVER\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_STORAGECLASS\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_STORAGEGROUP\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_MGTCLASS\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_MGTTRANSITION\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_COLLECTIONS\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_STRINGS\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_STGCLSDEVMGR\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_STGGRPCLASS\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_VOLUMES\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_STGGRPVOLUME\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_STAGING\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'SBTSBTABLES\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_LIBRARYSERVER\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_OBJECTS\' order by colno >> obj_getinfo.sql
echo select tbname, name, coltype, length, nulls, keyseq, colno \\ >> obj_getinfo.sql
echo from SYSIBM.SYSCOLUMNS where tbname=\'BASE_ACCESS\' order by colno >> obj_getinfo.sql

echo "rm exp.log exp/* tabdef.lst > /dev/null 2>&1" > obj_exp.cmd
echo db2 -fobj_exp.sql -rexp.log >> obj_exp.cmd
echo db2 -fobj_exp1.sql -rbase_access.asc >> obj_exp.cmd
echo db2 -fobj_exp2.sql -rbase_staging.asc >> obj_exp.cmd
echo db2 -fobj_exp3.sql -rvolume1.asc >> obj_exp.cmd
echo db2 -fobj_exp4.sql -rvolume2.asc >> obj_exp.cmd
echo db2 -fobj_exp5.sql -rbase_objects.asc >> obj_exp.cmd
echo db2 -fobj_getinfo.sql -rtabdef.lst >> obj_exp.cmd
#use existing file obj_exp.cmd to get files needed here
db2start
db2 connect to $FRNDB
. ./obj_exp.cmd
if [[ $? -eq 0 ]]; then
   #BASE_ACCESS.del format is different from other dels - format it first.  
   egrep -v "ACC_USERID|-----|selected|^$" base_access.asc|sed "s/^/|/g;s/  */,/g;s/,x'/|,|/g;s/',/|,/g" > $EXPDIR/BASE_ACCESS.del

   egrep -v "STA_ID|-----|selected|^$" base_staging.asc|sed "s/^  *//g;s/  */,/g;s/,$//g" > $EXPDIR/BASE_STAGING.del

#the base_volumes table have 3 lengthy fields, to format the output
#file for Oracle loader is not possible unless seperate into 2 files first,
#format both of them then do the cut and paste 

    egrep -v "VOL_VOLUMEID|------|selected|^$" volume1.asc|sed "s/  *$//g;s/^  *//g;s/\([0-9][0-9]*[.]*\)  */\1,/g;s/\(^[0-9][0-9]*\)  */\1,/g;s/\([a-zA-Z0-9][a-zA-Z0-9]*\)   */\1,/g;s/\([0-9][0-9]\/[0-9][0-9][0-9][0-9]\)$/\1,/g" > volume1.tmp

   egrep -v "VOL_MOUNTPOINT|-----|selected|^$" volume2.asc |sed "s/   */,/g;s/,$//g" > volume2.tmp
   cut -d, -f1,2 volume1.tmp > vol1.tmp
   cut -d, -f3-13 volume1.tmp > vol2.tmp
   paste -d, vol1.tmp volume2.tmp > vol3.tmp
   paste -d, vol3.tmp vol2.tmp > $EXPDIR/BASE_VOLUMES.del 
   rm volume1.asc volume2.asc volume1.tmp volume2.tmp vol1.tmp vol2.tmp vol3.tmp
 
   #there are 6 new columns in DL V2 base_cntl table, append these default values
   #to the end of each row in base_cntl.del
   cp $EXPDIR/BASE_CNTL.del BASE_CNTL.del.old
   if [[ $? -ne 0 ]]; then
      echo "Error occurred before default values added to BASE_CNTL table"
      exit 1
   fi
   sed 's/$/,|N|,24,|N|,24,10,|N|/g' BASE_CNTL.del.old > $EXPDIR/BASE_CNTL.del
   if [[ $? -ne 0 ]]; then
      echo "Error occurred while reformat BASE_CNTL.del"
      exit 1
   fi

   egrep -v "OBJ_OBJECTNAME|-----|selected|^$" base_objects.asc|sed "s/\(\.\)\(  *[0-9][0-9][0-9][0-9]\)/\2/g;s/  */,/g;s/,$//g" > $EXPDIR/BASE_OBJECTS.del
 
   egrep -v "^--|selected|TBNAME" tabdef.lst | sed 's/  */,/g' > tabdef.asc

   echo "BASE_CNTL,CTL_MPURGERENABLE,CHAR,1,N,-,28" >> tabdef.asc
   echo "BASE_CNTL,CTL_MPURGERCYCLE,SMALLINT,2,N,-,29" >> tabdef.asc
   echo "BASE_CNTL,CTL_MDESTAGRENABLE,CHAR,1,N,-,30" >> tabdef.asc
   echo "BASE_CNTL,CTL_MDESTAGRCYCLE,SMALLINT,2,N,-,31" >> tabdef.asc
   echo "BASE_CNTL,CTL_MSTAGEBATCHSZE,SMALLINT,2,N,-,32" >> tabdef.asc
   echo "BASE_CNTL,CTL_MEDIACONFIG,CHAR,1,N,-,33" >> tabdef.asc

   #use obj_tbl.lst to create ORACLE SQLLoader control file
   #build a list of table names -control.list- without empty tables 
   cat /dev/null > ctl.lst
   for filenm in `cat obj_tbl.lst`
   do
      if [[ -s $EXPDIR/$filenm.del ]];
      then
         echo $filenm.del  >> ctl.lst
         sed "s/   *|/|/g" $EXPDIR/$filenm.del > $EXPDIR/$filenm.tmp
#remove milisecond from data because Oracle does not support milisecond
         sed 's/\([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]-[0-9][0-9]\.[0-9][0-9]\.[0-9][0-9]\)\(\.[0-9][0-9][0-9][0-9][0-9][0-9]\)/\1/g;s/$/,/g' $EXPDIR/$filenm.tmp > $EXPDIR/$filenm.dat
         if [[ $? -ne 0 ]]; then 
            echo "\nFailed to store $filenm.dat in $EXPDIR"
            #dspmsg $MSG_MSGFILE $MSG_STOREFAIL "$MSG_MSGNOTFOUND" $filenm.dat "$EXPDIR"
         else
            rm $EXPDIR/$filenm.tmp
            echo "$filenm.dat created"
            #dspmsg $MSG_MSGFILE $MSG_STORESUCCEED "$MSG_MSGNOTFOUND" $filenm.dat "$EXPDIR"
         fi
      else
         mv $EXPDIR/$filenm.del $NODATA/$filenm.del > /dev/null 2>&1
      fi
   done
   cut -d\. -f1 ctl.lst > control.list

   sed 's/,TIMESTMP,/%DATE%\"YYYY-MM-DD-HH24.MI.SS\",SYSDATE,/g;s/,DATE,/%DATE%\"MM\/DD\/YYYY\",DATE,/g;s/,TIME,/%DATE%\"HH24.MI.SS\",DATE,/g' tabdef.asc > tabdef.date.asc
   cat /dev/null > $EXPDIR/load.sql
   cat /dev/null > tmp.ctl
   cat /dev/null > tmp1.ctl
   for i in `cat control.list`
   do
      echo sqlload userid=\$1\/\$2 control=exp\/$i.ctl log=exp\/$i\.log >> $EXPDIR/load.sql 
      echo LOAD DATA > tmp1.ctl
      echo INFILE \'exp\/$i.dat\' >> tmp1.ctl
      echo APPEND INTO TABLE $i >> tmp1.ctl
      echo FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\|\" \( >> tmp1.ctl
      grep -i $i, tabdef.date.asc|cut -f2 -d, > tmp.ctl
      cnt1=`cat tmp.ctl|wc -l`
      let k=0
      for line in `cat tmp.ctl`
      do
         let k=k+1
         if (( k == cnt1 )); then
            #$line has a comma in between column name and datatype
            #after echo command, the comma is no longer needed
            echo $line| sed 's/,/ /;s/%/ /g' >> tmp1.ctl
         else
            #remove the comma between fields, and add a comma at the
            #end of each line except the last line of the table
            echo $line| sed 's/,/ /;s/$/,/;s/%/ /g' >> tmp1.ctl
         fi
      done
      let k=0
      echo \) >> tmp1.ctl
      mv tmp1.ctl $EXPDIR/$i.ctl
   done
   rm tabdef.asc tmp.ctl control.list tabdef.date.asc ctl.lst tmp1.ctl base_staging.asc base_access.asc base_objects.asc BASE_CNTL.del.old > /dev/null 2>&1
   rm tabdef.lst obj_exp.cmd obj_exp.sql obj_exp1.sql obj_exp2.sql obj_exp3.sql obj_exp4.sql obj_exp5.sql obj_getinfo.sql obj_tbl.lst > /dev/null 2>&1
fi
