#!/bin/ksh
#***********************************************************************
# Digital Library Version 2 - 5765-C86.                                *
# VisualInfo Version 2 Release 3.0 - 5697-250.                         *
# (C) Copyright IBM Corp. 1994,1997.                                   *
# All Rights Reserved.                                                 *
#                                                                      *
# US Government Users Restricted Rights                                *
# Use, duplication or disclosure restricted by GSA ADP Schedule        *
# Contract with IBM Corp.                                              *
# Licensed Materials - Property of IBM                                 *
#***********************************************************************
#!/bin/ksh
#**********************************************************************#
# International Business Machines Corporation                          #
# Digital Library Version 2 - 5765-C86.                                #
# VisualInfo Version 2 Release 3.0 - 5697-250.                         #
# (C) Copyright IBM Corp. 1994, 1997                                   #
#**********************************************************************#

#------------------------------------------------------------------------------
#  Set up log file
#------------------------------------------------------------------------------
DBINSTALL=/tmp/installdb.log

#shutdown database if it is still up and running then delete datafiles
if [[ $DBEXIST = 1 ]]; then
   cnt=`ps -ef|grep $ORACLE_SID|wc -l`
   if [[ "$cnt" > 1 ]]; then
      export ORACLE_SID=$ORACLE_SID
outmsg=`svrmgrl<<- EOF
connect internal
shutdown abort
exit
EOF`
   fi
   #delete exist datafile
   rm $FRNDB_BASE/syst$FRNODBNAME.dbf > /dev/null 2>&1
   rm $FRNDB_BASE/log?$FRNODBNAME.dbf > /dev/null 2>&1
   rm $FRNDB_BASE/ctr*.ctl > /dev/null 2>&1
   rm $FRNDB_BASE/user*.dbf > /dev/null 2>&1
   rm $FRNDB_BASE/temp*.dbf > /dev/null 2>&1
   rm $FRNDB_BASE/rbs*.dbf > /dev/null 2>&1
   rm $FRNDB_BASE/obj*.dbf > /dev/null 2>&1
fi


################################
# create database $FRNODBNAME
################################
#create a temporary file, createdb_$FRNODBNAME.sh
FILENAME=$FRNDB_BASE/createdb_$FRNODBNAME.sh
CREATEDB=$FRNDB_BASE/createdb_$FRNODBNAME.sql
echo "export ORACLE_SID=$FRNODBNAME \n" >  $FILENAME
echo "svrmgrl command=@$CREATEDB\n"  >> $FILENAME
chmod u+x $FILENAME
. $FILENAME

if [[ $? -eq 0 ]]; then  #create database successfully
   dspmsg $MSG_MSGFILE $MSG_CREATEOSDBDONE "$MSG_MSGNOTFOUND" "$FRNODBNAME" \
        | tee -a $DBINSTALL
   rm $FILENAME > /dev/null 2>&1
   cp /tmp/$FRNODBNAME.tmp /tmp/createdb.log
   rm /tmp/$FRNODBNAME.tmp

# create user
svrmgrl<<- EOF
connect internal;
create user $FRNUSERID identified by $FRNPASSWD
    default tablespace objtbl
    quota unlimited on objtbl
    quota unlimited on objndx
    temporary tablespace temp;
grant create session, alter session, create table, create view to $FRNUSERID;
exit;
EOF

   if [[ $? -eq 0 ]]; then   #create user successfully
      #2542.ll echo "\nFinished creating user $FRNUSERID for database $FRNODBNAME"                | tee -a $DBINSTALL
      dspmsg $MSG_MSGFILE $MSG_CREATEUSERDONE "$MSG_MSGNOTFOUND" "$FRNUSERID" \
        "$FRNODBNAME" | tee -a $DBINSTALL

###########################################
#create $CREATETBL for default data
###########################################

CREATETBL=$FRNDB_BASE/crttbl.sql

echo "    CREATE TABLE BASE_CNTL" > $CREATETBL
echo "    ( CTL_CONFIGID              CHAR(16)      NOT null," >> $CREATETBL
echo "      CTL_CONFIGACTIVE          CHAR(1)," >> $CREATETBL
echo "      CTL_DESCRIPTION           CHAR(80)," >> $CREATETBL
echo "      CTL_PROCESSMAX            NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_LIBTIMEOUT            NUMBER(10,0)  NOT null," >> $CREATETBL
echo "      CTL_CLIENTTIMEOUT         NUMBER(10,0)  NOT null," >> $CREATETBL
echo "      CTL_PURGERTIMEOUT         NUMBER(10,0)  NOT null," >> $CREATETBL
echo "      CTL_MOUNTTIMEOUT          NUMBER(10,0)  NOT null," >> $CREATETBL
echo "      CTL_PURGERCYCLE           NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGRATORCYCLE         NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_DESTAGERCYCLE         NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_STAGEBATCHSIZE        NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGRABATCHSIZE        NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MAXLISTBOXMSGS        NUMBER(5,0)," >> $CREATETBL
echo "      CTL_MIGSTARTMON           CHAR(4)," >> $CREATETBL
echo "      CTL_MIGMONMINS            NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGSTARTTUE           CHAR(4)," >> $CREATETBL
echo "      CTL_MIGTUESMINS           NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGSTARTWED           CHAR(4)," >> $CREATETBL
echo "      CTL_MIGWEDMINS            NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGSTARTTHURS         CHAR(4)," >> $CREATETBL
echo "      CTL_MIGTHURSMINS          NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGSTARTFRI           CHAR(4)," >> $CREATETBL
echo "      CTL_MIGFRIMINS            NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGSTARTSAT           CHAR(4)," >> $CREATETBL
echo "      CTL_MIGSATMINS            NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MIGSTARTSUN           CHAR(4)," >> $CREATETBL
echo "      CTL_MIGSUNMINS            NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MPURGERENABLE         CHAR(1)       NOT null," >> $CREATETBL
echo "      CTL_MPURGERCYCLE          NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MDESTAGRENABLE        CHAR(1)       Not null," >> $CREATETBL
echo "      CTL_MDESTAGRCYCLE         NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MSTAGEBATCHSZE        NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      CTL_MEDIACONFIG           CHAR(1)       NOT null,       " >> $CREATETBL
echo "       PRIMARY KEY (CTL_CONFIGID));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STAGING" >> $CREATETBL
echo "    ( STA_ID                    NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      STA_SIZE                  NUMBER        NOT null," >> $CREATETBL
echo "      STA_SPACEUSED             NUMBER        NOT null," >> $CREATETBL
echo "      STA_PERCENTSTART          NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      STA_PERCENTSTOP           NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      STA_SERVERACTIVE          CHAR(1)       NOT null," >> $CREATETBL
echo "      STA_PATH                  VARCHAR(1023) NOT null," >> $CREATETBL
echo "      PRIMARY KEY(STA_ID));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STAGING_MEDIA" >> $CREATETBL
echo "    ( MST_ID                    NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      MST_SIZE                  NUMBER        NOT null," >> $CREATETBL
echo "      MST_SPACEUSED             NUMBER        NOT null," >> $CREATETBL
echo "      MST_PERCENTSTART          NUMBER(5,0)   Not null," >> $CREATETBL
echo "      MST_PERCENTSTOP           NUMBER(5,0)   NOT null," >> $CREATETBL
echo "      MST_SERVERACTIVE          CHAR(1)       NOT null," >> $CREATETBL
echo "      MST_SERVERNAME            VARCHAR(128)," >> $CREATETBL
echo "      MST_SERVERTYPE            CHAR(1)       NOT null," >> $CREATETBL
echo "      MST_MEDIAGROUP            VARCHAR(128)  NOT null," >> $CREATETBL
echo "      MST_PORTNUMBER            NUMBER(10,0)  Not null," >> $CREATETBL
echo "      PRIMARY KEY(MST_ID));" >> $CREATETBL
echo "      " >> $CREATETBL
echo "    CREATE TABLE BASE_OBJECTS" >> $CREATETBL
echo "    ( OBJ_OBJECTNAME       CHAR(44)           NOT null," >> $CREATETBL
echo "      OBJ_COLLECTIONID     NUMBER(5,0)        NOT null," >> $CREATETBL
echo "      OBJ_MGTCLASSID       NUMBER(5,0)        NOT null," >> $CREATETBL
echo "      OBJ_STGCLASSID       NUMBER(5,0)        NOT null," >> $CREATETBL
echo "      OBJ_VOLUMEID         NUMBER(10,0)       NOT null," >> $CREATETBL
echo "      OBJ_PATH             NUMBER(10,0)       NOT null," >> $CREATETBL
echo "      OBJ_FILENAME         CHAR(12)," >> $CREATETBL
echo "      OBJ_ATTRIBUTES       NUMBER(5,0)        NOT null," >> $CREATETBL
echo "      OBJ_STATUS           CHAR(1)," >> $CREATETBL
echo "      OBJ_SIZE             NUMBER             NOT null," >> $CREATETBL
echo "      OBJ_CREATEDATE       DATE               NOT null," >> $CREATETBL
echo "      OBJ_REFERENCEDDATE   DATE               NOT null," >> $CREATETBL
echo "      OBJ_ACTIONDATE       DATE               NOT null," >> $CREATETBL
echo "      OBJ_MGTCLASSDATE     DATE               NOT null," >> $CREATETBL
echo "      OBJ_STGCLASSDATE     DATE               NOT null," >> $CREATETBL
echo "      OBJ_RETENTION        NUMBER(10,0)       NOT null," >> $CREATETBL
echo "      OBJ_LIBRARYID        NUMBER(5,0)        NOT null," >> $CREATETBL
echo "      PRIMARY KEY (OBJ_OBJECTNAME));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE INDEX OBJ_ACTION_IDX" >> $CREATETBL
echo "       ON BASE_OBJECTS " >> $CREATETBL
echo "        (OBJ_ACTIONDATE      ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_OBJECTS_MEDIA" >> $CREATETBL
echo "    ( MOB_OBJECTNAME      CHAR(44)            NOT null," >> $CREATETBL
echo "      MOB_COLLECTIONID    NUMBER(5,0)         NOT null," >> $CREATETBL
echo "      MOB_MGTCLASSID      NUMBER(5,0)         NOT null," >> $CREATETBL
echo "      MOB_STGCLASSID      NUMBER(5,0)         NOT null," >> $CREATETBL
echo "      MOB_VOLUMEID        NUMBER(10,0)        NOT null," >> $CREATETBL
echo "      MOB_PATH            NUMBER(10,0)        NOT null," >> $CREATETBL
echo "      MOB_FILENAME        CHAR(12),         " >> $CREATETBL
echo "      MOB_ATTRIBUTES      NUMBER(5,0)         NOT null," >> $CREATETBL
echo "      MOB_PLAYSTATUS      CHAR(1),  " >> $CREATETBL
echo "      MOB_STAGINGSTATUS   CHAR(1)," >> $CREATETBL
echo "      MOB_VOLSTATUS       CHAR(1)," >> $CREATETBL
echo "      MOB_SIZE            NUMBER              NOT null," >> $CREATETBL
echo "      MOB_CREATEDATE      DATE                NOT null," >> $CREATETBL
echo "      MOB_REFERENCEDDATE  DATE                NOT null," >> $CREATETBL
echo "      MOB_ACTIONDATE      DATE                NOT null," >> $CREATETBL
echo "      MOB_MGTCLASSDATE    DATE                NOT null," >> $CREATETBL
echo "      MOB_STGCLASSDATE    DATE                NOT null," >> $CREATETBL
echo "      MOB_RETENTION       NUMBER(10,0)        NOT null," >> $CREATETBL
echo "      MOB_LIBRARYID       NUMBER(5,0)         NOT null," >> $CREATETBL
echo "      PRIMARY KEY (MOB_OBJECTNAME));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE INDEX MOB_ACTION_IDX" >> $CREATETBL
echo "       ON BASE_OBJECTS_MEDIA " >> $CREATETBL
echo "        (MOB_ACTIONDATE      ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STORAGEGROUP" >> $CREATETBL
echo "    ( STG_STGGROUPID      NUMBER(5,0)                      NOT null," >> $CREATETBL
echo "      STG_STGGROUPNAME    CHAR(32)                         NOT null," >> $CREATETBL
echo "       PRIMARY KEY (STG_STGGROUPID));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE UNIQUE INDEX STG_STGGRPNAME_IDX" >> $CREATETBL
echo "       ON BASE_STORAGEGROUP" >> $CREATETBL
echo "          ( STG_STGGROUPNAME    ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_MGTCLASS" >> $CREATETBL
echo "    ( MGC_MGTCLASSID      NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "      MGC_MGTCLASSNAME    CHAR(8)                         NOT null," >> $CREATETBL
echo "      MGC_TRANSPERIOD     NUMBER(10,0)                    NOT null," >> $CREATETBL
echo "      MGC_TRANSTARGETID   NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "      MGC_RETENTION       NUMBER(10,0)                    NOT null," >> $CREATETBL
echo "       PRIMARY KEY (MGC_MGTCLASSID));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE UNIQUE INDEX MGC_MGTCLSNAME_IDX" >> $CREATETBL
echo "       ON BASE_MGTCLASS" >> $CREATETBL
echo "          ( MGC_MGTCLASSNAME      ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_COLLECTIONS" >> $CREATETBL
echo "    ( COL_COLLID           NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "      COL_COLLNAME         CHAR(44)                        NOT null," >> $CREATETBL
echo "      COL_STGGROUPID       NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "      COL_MGTCLASSID       NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "       PRIMARY KEY (COL_COLLID)," >> $CREATETBL
echo "       FOREIGN KEY (COL_STGGROUPID) REFERENCES BASE_STORAGEGROUP," >> $CREATETBL
echo "       FOREIGN KEY (COL_MGTCLASSID) REFERENCES BASE_MGTCLASS);" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE UNIQUE INDEX COL_COLLNAME_IDX" >> $CREATETBL
echo "       ON BASE_COLLECTIONS" >> $CREATETBL
echo "          ( COL_COLLNAME      ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_DEVMGR " >> $CREATETBL
echo "    ( DEV_DEVMGRID         NUMBER(5,0)                     NOT null, " >> $CREATETBL
echo "      DEV_DEVMGRNAME       CHAR(8)                         NOT null, " >> $CREATETBL
echo "      DEV_ATTRIBUTES       CHAR(8), " >> $CREATETBL
echo "      DEV_ENABLE           CHAR(1), " >> $CREATETBL
echo "      DEV_DESCRIPTION      VARCHAR(80), " >> $CREATETBL
echo "      DEV_PARAMETERS       VARCHAR(128), " >> $CREATETBL
echo "      PRIMARY KEY (DEV_DEVMGRID));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE UNIQUE INDEX DEV_DEVMGRNAME_IDX " >> $CREATETBL
echo "       ON BASE_DEVMGR " >> $CREATETBL
echo "          ( DEV_DEVMGRNAME      ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_LIBRARYSERVER" >> $CREATETBL
echo "    ( LIB_LIBRARYID       NUMBER(5,0)           NOT null," >> $CREATETBL
echo "      LIB_LIBRARYNAME     CHAR(26)              NOT null," >> $CREATETBL
echo "      LIB_ATTRIBUTES      NUMBER(10,0)          NOT null," >> $CREATETBL
echo "       PRIMARY KEY (LIB_LIBRARYID));" >> $CREATETBL
echo "" >> $CREATETBL
echo " CREATE UNIQUE INDEX LIB_LIBNAME_IDX" >> $CREATETBL
echo "       ON BASE_LIBRARYSERVER" >> $CREATETBL
echo "          ( LIB_LIBRARYNAME      ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_ACCESS" >> $CREATETBL
echo "    ( ACC_USERID          CHAR(26)                       NOT null," >> $CREATETBL
echo "      ACC_PASSWORD        RAW(8)                         NOT null," >> $CREATETBL
echo "      ACC_ATTRIBUTES      NUMBER(10,0)                   NOT null," >> $CREATETBL
echo "      ACC_LIBRARYID       NUMBER(5,0)                    NOT null," >> $CREATETBL
echo "       PRIMARY KEY (ACC_USERID)," >> $CREATETBL
echo "       FOREIGN KEY (ACC_LIBRARYID) REFERENCES BASE_LIBRARYSERVER);" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_OBJECTSERVER" >> $CREATETBL
echo "    ( BOS_OBJECTSERVERID  NUMBER(5,0)           NOT null," >> $CREATETBL
echo "      BOS_OBJSERVERNAME   CHAR(26)              NOT null," >> $CREATETBL
echo "      BOS_ATTRIBUTES      NUMBER(10,0)          NOT null," >> $CREATETBL
echo "       PRIMARY KEY (BOS_OBJECTSERVERID));" >> $CREATETBL
echo "" >> $CREATETBL
echo " CREATE UNIQUE INDEX BOS_OBJNAME_IDX" >> $CREATETBL
echo "       ON BASE_OBJECTSERVER" >> $CREATETBL
echo "          ( BOS_OBJSERVERNAME      ASC)" >> $CREATETBL
echo "       TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STORAGECLASS" >> $CREATETBL
echo "    ( STC_STGCLASSID      NUMBER(5,0)                         NOT null," >> $CREATETBL
echo "      STC_STGCLASSNAME    CHAR(8)                             NOT null," >> $CREATETBL
echo "      STC_ATTRIBUTES      NUMBER(10,0)                        NOT null," >> $CREATETBL
echo "      STC_OBJECTSERVERID  NUMBER(5,0)                         NOT null," >> $CREATETBL
echo "      STC_REMOTECOLLNAME  VARCHAR(44)," >> $CREATETBL
echo "      STC_REMOTEMGCNAME   VARCHAR(8)," >> $CREATETBL
echo "      STC_REMOTESTCNAME   VARCHAR(8)," >> $CREATETBL
echo "      STC_REMOTERETENTN   NUMBER(10,0)                        NOT null," >> $CREATETBL
echo "       PRIMARY KEY (STC_STGCLASSID)," >> $CREATETBL
echo "       FOREIGN KEY (STC_OBJECTSERVERID) REFERENCES BASE_OBJECTSERVER);" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE UNIQUE INDEX STC_STGCLSNAME_IDX" >> $CREATETBL
echo "       ON BASE_STORAGECLASS" >> $CREATETBL
echo "          ( STC_STGCLASSNAME      ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STGCLSDEVMGR" >> $CREATETBL
echo "    ( SCD_STGCLASSID      NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "      SCD_DEVMGRID        NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "       PRIMARY KEY (SCD_STGCLASSID, SCD_DEVMGRID)," >> $CREATETBL
echo "       FOREIGN KEY (SCD_STGCLASSID) REFERENCES BASE_STORAGECLASS," >> $CREATETBL
echo "       FOREIGN KEY (SCD_DEVMGRID) REFERENCES BASE_DEVMGR);" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_VOLUMES" >> $CREATETBL
echo "    ( VOL_VOLUMEID        NUMBER(10,0)                      NOT null," >> $CREATETBL
echo "      VOL_LOGICALNAME     CHAR(254)                         NOT null," >> $CREATETBL
echo "      VOL_MOUNTPOINT      VARCHAR(1023)                     NOT null," >> $CREATETBL
echo "      VOL_PATH            VARCHAR(1023)                     NOT null," >> $CREATETBL
echo "      VOL_DEVMGRID        NUMBER(5,0)                       NOT null," >> $CREATETBL
echo "      VOL_STGCLASSID      NUMBER(5,0)                       NOT null," >> $CREATETBL
echo "      VOL_SIZE            NUMBER                            NOT null," >> $CREATETBL
echo "      VOL_FREESPACE       NUMBER                            NOT null," >> $CREATETBL
echo "      VOL_ATTRIBUTES      NUMBER(5,0)                       NOT null," >> $CREATETBL
echo "      VOL_MEDIATYPE       NUMBER(5,0)                       NOT null," >> $CREATETBL
echo "      VOL_STATUS          CHAR(1)," >> $CREATETBL
echo "      VOL_NUMBUCKETS      NUMBER(5,0)                       NOT null," >> $CREATETBL
echo "      VOL_REFERENCEDDATE  DATE                              NOT null," >> $CREATETBL
echo "      VOL_OFFLINELOC      VARCHAR(128)," >> $CREATETBL
echo "       PRIMARY KEY (VOL_VOLUMEID)," >> $CREATETBL
echo "       FOREIGN KEY (VOL_STGCLASSID) REFERENCES BASE_STORAGECLASS," >> $CREATETBL
echo "       FOREIGN KEY (VOL_STGCLASSID, VOL_DEVMGRID) REFERENCES BASE_STGCLSDEVMGR);" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE UNIQUE INDEX VOL_VOLSER_IDX" >> $CREATETBL
echo "         ON BASE_VOLUMES" >> $CREATETBL
echo "         (VOL_LOGICALNAME ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STGGRPVOLUME" >> $CREATETBL
echo "    ( SGV_STGGROUPID      NUMBER(5,0)                     NOT null," >> $CREATETBL
echo "      SGV_VOLUMEID        NUMBER(10,0)                    NOT null," >> $CREATETBL
echo "       PRIMARY KEY (SGV_STGGROUPID, SGV_VOLUMEID)," >> $CREATETBL
echo "       FOREIGN KEY (SGV_STGGROUPID) REFERENCES BASE_STORAGEGROUP," >> $CREATETBL
echo "       FOREIGN KEY (SGV_VOLUMEID) REFERENCES BASE_VOLUMES);" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STGGRPCLASS" >> $CREATETBL
echo "    ( SGC_STGGROUPID      NUMBER(5,0)                          NOT null," >> $CREATETBL
echo "      SGC_STGCLASSID      NUMBER(5,0)                          NOT null," >> $CREATETBL
echo "       PRIMARY KEY (SGC_STGGROUPID, SGC_STGCLASSID)," >> $CREATETBL
echo "       FOREIGN KEY (SGC_STGGROUPID) REFERENCES BASE_STORAGEGROUP," >> $CREATETBL
echo "       FOREIGN KEY (SGC_STGCLASSID) REFERENCES BASE_STORAGECLASS);" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_MGTTRANSITION" >> $CREATETBL
echo "    ( MGP_MGTCLASSID      NUMBER(5,0)                          NOT null," >> $CREATETBL
echo "      MGP_SEQUENCENUM     NUMBER(5,0)                          NOT null," >> $CREATETBL
echo "      MGP_STGCLASSID      NUMBER(5,0)                          NOT null," >> $CREATETBL
echo "      MGP_LASTREFER       NUMBER(10,0)                         NOT null," >> $CREATETBL
echo "      MGP_SINCEENTER      NUMBER(10,0)                         NOT null," >> $CREATETBL
echo "      MGP_STAGECYCLE      NUMBER(10,0)                         NOT null," >> $CREATETBL
echo "      MGP_STAGETIMES      NUMBER(10,0)                         NOT null," >> $CREATETBL
echo "       PRIMARY KEY (MGP_MGTCLASSID, MGP_SEQUENCENUM)," >> $CREATETBL
echo "       FOREIGN KEY (MGP_MGTCLASSID) REFERENCES BASE_MGTCLASS" >> $CREATETBL
echo "               ," >> $CREATETBL
echo "       FOREIGN KEY (MGP_STGCLASSID) REFERENCES BASE_STORAGECLASS" >> $CREATETBL
echo "               );" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE UNIQUE INDEX MGP_MGTSTGCLS_IDX" >> $CREATETBL
echo "       ON BASE_MGTTRANSITION" >> $CREATETBL
echo "          ( MGP_MGTCLASSID         ASC," >> $CREATETBL
echo "           MGP_STGCLASSID         ASC)" >> $CREATETBL
echo "        TABLESPACE objndx;" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_STRINGS" >> $CREATETBL
echo "    ( STR_STRINGID        NUMBER(10,0)                         NOT null," >> $CREATETBL
echo "      STR_USECNT          NUMBER(10,0)                         NOT null," >> $CREATETBL
echo "      STR_STRING          VARCHAR(254)," >> $CREATETBL
echo "       PRIMARY KEY (STR_STRINGID));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE SBTSBTABLES" >> $CREATETBL
echo "    ( LastReorgTS         DATE                   NOT null," >> $CREATETBL
echo "     ReorgIndicator      NUMBER(5,0)            NOT null," >> $CREATETBL
echo "     ServerType          CHAR(4)," >> $CREATETBL
echo "     TableName           VARCHAR(27)," >> $CREATETBL
echo "     IndexName           VARCHAR(27));" >> $CREATETBL
echo "" >> $CREATETBL
echo "    CREATE TABLE BASE_VERSION                " >> $CREATETBL
echo "    ( Platform         CHAR(17)     NOT null," >> $CREATETBL
echo "      Version          NUMBER(10,0) NOT null," >> $CREATETBL
echo "      LastUpdated      DATE         NOT null," >> $CREATETBL
echo "      Created          DATE         NOT null );" >> $CREATETBL
echo "" >> $CREATETBL

echo "INSERT INTO BASE_CNTL VALUES ('IBMCONFIG','N','IBM DEFAULT CONFIGURATION',5,600000,600000,600000,600000,5,30,15,50,50,50,'0000',1440,'0000',1440,'0000',1440,'0000',1440,'0000',1440,'0000',1440,'0000',1440,'N',24,'N',24,10,'N');" >> $CREATETBL
echo "INSERT INTO BASE_DEVMGR VALUES (1,'FRNXHDDM','00000000','Y','IBM FIXED DISK DEVICE MANAGER','');" >> $CREATETBL
echo "INSERT INTO BASE_DEVMGR VALUES (2,'FRNXADDM','00000002','N','IBM ADSM DEVICE MANAGER','');" >> $CREATETBL
echo "INSERT INTO BASE_DEVMGR VALUES (3,'FRNXMADM','00000004','N','IBM MEDIA ARCHIVER DEVICE MANAGER','');" >> $CREATETBL
echo "INSERT INTO BASE_OBJECTSERVER VALUES (0,'IBMRESERVED',0);" >> $CREATETBL
echo "INSERT INTO BASE_STORAGECLASS VALUES (1,'FIXED',1,0,'','','',0);" >> $CREATETBL
echo "INSERT INTO BASE_STORAGECLASS VALUES (2,'MEDIASTC',1,0,'','','',0);" >> $CREATETBL
echo "INSERT INTO BASE_STORAGEGROUP VALUES (1,'GROUP01');" >> $CREATETBL
echo "INSERT INTO BASE_STORAGEGROUP VALUES (2,'MEDIASTG');" >> $CREATETBL
echo "INSERT INTO BASE_MGTCLASS VALUES (1,'MGTCLASS',0,0,0);" >> $CREATETBL
echo "INSERT INTO BASE_MGTCLASS VALUES (2,'MEDIAMGC',0,0,0);" >> $CREATETBL
echo "INSERT INTO BASE_MGTTRANSITION VALUES (1,1,1,1,30,0,12);" >> $CREATETBL
echo "INSERT INTO BASE_MGTTRANSITION VALUES (2,1,2,1,30,0,12);" >> $CREATETBL
echo "INSERT INTO BASE_COLLECTIONS VALUES (1,'CBR.CLLCT001',1,1);" >> $CREATETBL
echo "INSERT INTO BASE_COLLECTIONS VALUES (2,'Media.Collectn.Archive',2,2);" >> $CREATETBL
echo "INSERT INTO BASE_COLLECTIONS VALUES (3,'Media.Collectn.NoArchiv',2,2);" >> $CREATETBL
echo "INSERT INTO BASE_STRINGS VALUES (1,1,'/lbosdata/');" >> $CREATETBL
echo "INSERT INTO BASE_STGCLSDEVMGR VALUES (1,1);" >> $CREATETBL
echo "INSERT INTO BASE_STGCLSDEVMGR VALUES (2,3);" >> $CREATETBL
echo "INSERT INTO BASE_STGGRPCLASS VALUES (1,1);" >> $CREATETBL
echo "INSERT INTO BASE_STGGRPCLASS VALUES (2,2);" >> $CREATETBL
echo "INSERT INTO BASE_VOLUMES VALUES (1,'$FRNOLOGICALNAME','$FRNOBJMPT','$FRNOBJVPATH',1,1,0,0,0,0,'A',1,SYSDATE, 'Offline');" >> $CREATETBL
echo "INSERT INTO BASE_VOLUMES VALUES (2,'MSARCHIV','MSARCHIV','MSARCHIV',3,2,0,0,0,181,'A',1,SYSDATE, 'Offline');" >> $CREATETBL
echo "INSERT INTO BASE_STGGRPVOLUME VALUES (1,1);" >> $CREATETBL
echo "INSERT INTO BASE_STGGRPVOLUME VALUES (2,2);" >> $CREATETBL
echo "INSERT INTO BASE_STAGING VALUES (1,208666624.0,0.0,80,60,'N', '$FRNOBJPATH');" >> $CREATETBL
echo "INSERT INTO BASE_STAGING_MEDIA VALUES (1,0.0, 0.0,80,60,'N','','M','OBJSRVRX',23800);"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_CNTL','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STAGING','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_OBJECTS','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_COLLECTIONS','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_DEVMGR','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_ACCESS','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STORAGECLASS','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STGCLSDEVMGR','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_VOLUMES','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STORAGEGROUP','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STGGRPVOLUME','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STGGRPCLASS','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_MGTCLASS','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_MGTTRANSITION','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STRINGS','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_LIBRARYSERVER','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_OBJECTSERVER','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_OBJECTS_MEDIA','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_STAGING_MEDIA','NONE');"  >> $CREATETBL
echo "INSERT INTO SBTSBTABLES VALUES (SYSDATE, 1, 'LBOS',  '$FRNUSERID.BASE_VERSION','NONE');" >> $CREATETBL
echo "INSERT INTO BASE_LIBRARYSERVER VALUES (0,'IBMRESERVED',0);" >> $CREATETBL
echo "INSERT INTO BASE_LIBRARYSERVER VALUES (1,'$FRNLDBNAME',0);" >> $CREATETBL
echo "INSERT INTO BASE_ACCESS VALUES ('FRN\$PUBLIC','FED0F6C9018BCF4A',2,1);" >> $CREATETBL
echo "INSERT INTO BASE_VERSION VALUES ('AIX',0,SYSDATE,SYSDATE);" >> $CREATETBL

if  [[ $FRNMEDIA -eq 1 ]]; then
echo "UPDATE BASE_CNTL SET CTL_MEDIACONFIG='Y';" >> $CREATETBL
echo "UPDATE BASE_DEVMGR SET DEV_ENABLE='Y' WHERE DEV_DEVMGRID=3;" >> $CREATETBL
echo "UPDATE BASE_STAGING_MEDIA SET MST_SERVERNAME='$FRNMSNAME',"  >> $CREATETBL
echo "  MST_MEDIAGROUP='$FRNMSGROUP',MST_SERVERTYPE='$FRNMSTYPE';" >> $CREATETBL
fi

svrmgrl<<- EOF
connect $FRNUSERID/$FRNPASSWD
spool /tmp/createtbl.log
@$CREATETBL
spool off
EOF
      if [[ $? -eq 0 ]]; then #create tables successfully
         dspmsg $MSG_MSGFILE $MSG_CREATEOSTBLDONE "$MSG_MSGNOTFOUND" \
                "$FRNODBNAME" | tee -a $DBINSTALL
      else
         dspmsg $MSG_MSGFILE $MSG_CREATETABLEERROR "$MSG_MSGNOTFOUND" "$?" \
                | tee -a $DBINSTALL
         exit 1
      fi #end of create tables successfully
   else
      dspmsg $MSG_MSGFILE $MSG_CREATEUSERERROR "$MSG_MSGNOTFOUND" "$FRNUSERID" "$?" \
        "$FRNUSERID"  | tee -a $DBINSTALL
      exit 1
   fi  #end of create user
else
    dspmsg $MSG_MSGFILE $MSG_DBCREATEERROR "$MSG_MSGNOTFOUND" "$FRNODBNAME" "$?" \
        "$?" | tee -a $DBINSTALL
    exit 1
fi  #end of create database

cat /tmp/createtbl.log >>  /tmp/createdb.log
dspmsg $MSG_MSGFILE $MSG_DBCREATIONLOG "$MSG_MSGNOTFOUND" "/tmp/createdb.log" \
        | tee -a $DBINSTALL
dspmsg $MSG_MSGFILE $MSG_TBCREATIONLOG "$MSG_MSGNOTFOUND" \
        "/tmp/createtbl.log" | tee -a $DBINSTALL
dspmsg $MSG_MSGFILE $MSG_LOGFILE "$MSG_MSGNOTFOUND" "$DBINSTALL" \
        | tee -a $DBINSTALL

#create file startdbm.sh, stopdbm.sh for startup
#or shutdown database
FRNSTARTUP=$FRNDB_BASE/startdbm.sh
echo FRNODBNAME=$FRNODBNAME > $FRNSTARTUP

if [[ $? -eq 0 ]]; then
   cat $FRNROOT/frnstart.objdbi >> $FRNSTARTUP
   if [[ $? -eq 0 ]]; then
      chmod u+x $FRNSTARTUP
   else
      dspmsg $MSG_MSGFILE $MSG_FILECREATEERROR "$MSG_MSGNOTFOUND" \
        "$FRNSTARTUP" "$?" | tee -a $DBINSTALL
      exit 1
   fi
else
   dspmsg $MSG_MSGFILE $MSG_FILECREATEERROR "$MSG_MSGNOTFOUND" \
        "$FRNSTARTUP" "$?" | tee -a $DBINSTALL
   exit 1
fi
FRNSTOP=$FRNDB_BASE/stopdbm.sh
echo FRNODBNAME=$FRNODBNAME > $FRNSTOP
if [[ $? -eq 0 ]]; then
   cat $FRNROOT/frnstop.objdbi >> $FRNSTOP #M6401ll
   if [[ $? -eq 0 ]]; then
      chmod u+x $FRNSTOP
   else
      dspmsg $MSG_MSGFILE $MSG_FILECREATEERROR "$MSG_MSGNOTFOUND" \
        "$FRNSTOP" "$?" | tee -a $DBINSTALL
      exit 1
   fi
else
   dspmsg $MSG_MSGFILE $MSG_FILECREATEERROR "$MSG_MSGNOTFOUND" \
        "$FRNSTOP" "$?" | tee -a $DBINSTALL
   exit 1
fi

# Terminate the database process


return
